\ This file has been generated using SWIG and fsi,
\ and is already platform dependent, search for the corresponding
\ fsi-file to compile it where no one has compiled it before ;)
\ Forth systems have their own own dynamic loader and don't need addional C-Code.
\ That's why this file will just print normal forth-code once compiled
\ and can be used directly with include or require.
\ As all comments are stripped during the compilation, please
\ insert the copyright notice of the original file here.

\ ----===< prefix >===-----
cs-vocabulary webp

get-current also webp definitions

c-library webp

s" webp" add-lib
\c #include <webp/decode.h>
\c #include <webp/encode.h>
\c #ifdef __gnu_linux__
\c #undef stderr
\c extern struct _IO_FILE *stderr;
\c #endif

\ ----===< int constants >===-----
#521	constant WEBP_DECODER_ABI_VERSION
#527	constant WEBP_ENCODER_ABI_VERSION
#16383	constant WEBP_MAX_DIMENSION

\ --------===< enums >===---------
#0	constant MODE_RGB
#1	constant MODE_RGBA
#2	constant MODE_BGR
#3	constant MODE_BGRA
#4	constant MODE_ARGB
#5	constant MODE_RGBA_4444
#6	constant MODE_RGB_565
#7	constant MODE_rgbA
#8	constant MODE_bgrA
#9	constant MODE_Argb
#10	constant MODE_rgbA_4444
#11	constant MODE_YUV
#12	constant MODE_YUVA
#13	constant MODE_LAST
#0	constant VP8_STATUS_OK
#1	constant VP8_STATUS_OUT_OF_MEMORY
#2	constant VP8_STATUS_INVALID_PARAM
#3	constant VP8_STATUS_BITSTREAM_ERROR
#4	constant VP8_STATUS_UNSUPPORTED_FEATURE
#5	constant VP8_STATUS_SUSPENDED
#6	constant VP8_STATUS_USER_ABORT
#7	constant VP8_STATUS_NOT_ENOUGH_DATA
#0	constant WEBP_HINT_DEFAULT
#1	constant WEBP_HINT_PICTURE
#2	constant WEBP_HINT_PHOTO
#3	constant WEBP_HINT_GRAPH
#4	constant WEBP_HINT_LAST
#0	constant WEBP_PRESET_DEFAULT
#1	constant WEBP_PRESET_PICTURE
#2	constant WEBP_PRESET_PHOTO
#3	constant WEBP_PRESET_DRAWING
#4	constant WEBP_PRESET_ICON
#5	constant WEBP_PRESET_TEXT
#0	constant WEBP_YUV420
#4	constant WEBP_YUV420A
#3	constant WEBP_CSP_UV_MASK
#4	constant WEBP_CSP_ALPHA_BIT
#0	constant VP8_ENC_OK
#1	constant VP8_ENC_ERROR_OUT_OF_MEMORY
#2	constant VP8_ENC_ERROR_BITSTREAM_OUT_OF_MEMORY
#3	constant VP8_ENC_ERROR_NULL_PARAMETER
#4	constant VP8_ENC_ERROR_INVALID_CONFIGURATION
#5	constant VP8_ENC_ERROR_BAD_DIMENSION
#6	constant VP8_ENC_ERROR_PARTITION0_OVERFLOW
#7	constant VP8_ENC_ERROR_PARTITION_OVERFLOW
#8	constant VP8_ENC_ERROR_BAD_WRITE
#9	constant VP8_ENC_ERROR_FILE_TOO_BIG
#10	constant VP8_ENC_ERROR_USER_ABORT
#11	constant VP8_ENC_ERROR_LAST

\ -------===< structs >===--------
\ struct WebPRGBABuffer
begin-structure WebPRGBABuffer
	drop 0 8 +field WebPRGBABuffer-rgba
	drop 16 8 +field WebPRGBABuffer-size
	drop 8 4 +field WebPRGBABuffer-stride
drop 24 end-structure
\ struct WebPYUVABuffer
begin-structure WebPYUVABuffer
	drop 56 8 +field WebPYUVABuffer-u_size
	drop 48 8 +field WebPYUVABuffer-y_size
	drop 0 8 +field WebPYUVABuffer-y
	drop 64 8 +field WebPYUVABuffer-v_size
	drop 72 8 +field WebPYUVABuffer-a_size
	drop 32 4 +field WebPYUVABuffer-y_stride
	drop 36 4 +field WebPYUVABuffer-u_stride
	drop 40 4 +field WebPYUVABuffer-v_stride
	drop 44 4 +field WebPYUVABuffer-a_stride
	drop 8 8 +field WebPYUVABuffer-u
	drop 16 8 +field WebPYUVABuffer-v
	drop 24 8 +field WebPYUVABuffer-a
drop 80 end-structure
\ struct WebPDecBuffer
begin-structure WebPDecBuffer
	drop 12 4 +field WebPDecBuffer-is_external_memory
	drop 112 8 +field WebPDecBuffer-private_memory
	drop 0 4 +field WebPDecBuffer-colorspace
	drop 8 4 +field WebPDecBuffer-height
	drop 4 4 +field WebPDecBuffer-width
	drop 16 80 +field WebPDecBuffer-u
	drop 96 16 +field WebPDecBuffer-pad
drop 120 end-structure
\ WebPDecBuffer_u
begin-structure WebPDecBuffer_u
	drop 0 24 +field WebPDecBuffer_u-RGBA
	drop 0 80 +field WebPDecBuffer_u-YUVA
drop 80 end-structure
\ struct WebPBitstreamFeatures
begin-structure WebPBitstreamFeatures
	drop 4 4 +field WebPBitstreamFeatures-height
	drop 0 4 +field WebPBitstreamFeatures-width
	drop 16 4 +field WebPBitstreamFeatures-format
	drop 20 20 +field WebPBitstreamFeatures-pad
	drop 8 4 +field WebPBitstreamFeatures-has_alpha
	drop 12 4 +field WebPBitstreamFeatures-has_animation
drop 40 end-structure
\ struct WebPDecoderOptions
begin-structure WebPDecoderOptions
	drop 16 4 +field WebPDecoderOptions-crop_top
	drop 12 4 +field WebPDecoderOptions-crop_left
	drop 8 4 +field WebPDecoderOptions-use_cropping
	drop 32 4 +field WebPDecoderOptions-scaled_width
	drop 20 4 +field WebPDecoderOptions-crop_width
	drop 40 4 +field WebPDecoderOptions-use_threads
	drop 0 4 +field WebPDecoderOptions-bypass_filtering
	drop 36 4 +field WebPDecoderOptions-scaled_height
	drop 24 4 +field WebPDecoderOptions-crop_height
	drop 48 4 +field WebPDecoderOptions-flip
	drop 28 4 +field WebPDecoderOptions-use_scaling
	drop 56 20 +field WebPDecoderOptions-pad
	drop 52 4 +field WebPDecoderOptions-alpha_dithering_strength
	drop 44 4 +field WebPDecoderOptions-dithering_strength
	drop 4 4 +field WebPDecoderOptions-no_fancy_upsampling
drop 76 end-structure
\ struct WebPDecoderConfig
begin-structure WebPDecoderConfig
	drop 0 40 +field WebPDecoderConfig-input
	drop 40 120 +field WebPDecoderConfig-output
	drop 160 76 +field WebPDecoderConfig-options
drop 240 end-structure
\ struct WebPConfig
begin-structure WebPConfig
	drop 76 4 +field WebPConfig-partition_limit
	drop 84 4 +field WebPConfig-thread_level
	drop 8 4 +field WebPConfig-method
	drop 4 4 +field WebPConfig-quality
	drop 56 4 +field WebPConfig-alpha_quality
	drop 88 4 +field WebPConfig-low_memory
	drop 112 4 +field WebPConfig-qmax
	drop 40 4 +field WebPConfig-filter_type
	drop 20 4 +field WebPConfig-target_PSNR
	drop 52 4 +field WebPConfig-alpha_filtering
	drop 60 4 +field WebPConfig-pass
	drop 80 4 +field WebPConfig-emulate_jpeg_size
	drop 104 4 +field WebPConfig-use_sharp_yuv
	drop 68 4 +field WebPConfig-preprocessing
	drop 72 4 +field WebPConfig-partitions
	drop 48 4 +field WebPConfig-alpha_compression
	drop 96 4 +field WebPConfig-exact
	drop 100 4 +field WebPConfig-use_delta_palette
	drop 108 4 +field WebPConfig-qmin
	drop 0 4 +field WebPConfig-lossless
	drop 12 4 +field WebPConfig-image_hint
	drop 92 4 +field WebPConfig-near_lossless
	drop 36 4 +field WebPConfig-filter_sharpness
	drop 44 4 +field WebPConfig-autofilter
	drop 24 4 +field WebPConfig-segments
	drop 32 4 +field WebPConfig-filter_strength
	drop 28 4 +field WebPConfig-sns_strength
	drop 64 4 +field WebPConfig-show_compressed
	drop 16 4 +field WebPConfig-target_size
drop 116 end-structure
\ struct WebPAuxStats
begin-structure WebPAuxStats
	drop 124 16 +field WebPAuxStats-segment_level
	drop 0 4 +field WebPAuxStats-coded_size
	drop 44 48 +field WebPAuxStats-residual_bytes
	drop 36 8 +field WebPAuxStats-header_bytes
	drop 24 12 +field WebPAuxStats-block_count
	drop 156 4 +field WebPAuxStats-transform_bits
	drop 160 4 +field WebPAuxStats-cache_bits
	drop 144 4 +field WebPAuxStats-layer_data_size
	drop 140 4 +field WebPAuxStats-alpha_data_size
	drop 172 4 +field WebPAuxStats-lossless_hdr_size
	drop 176 4 +field WebPAuxStats-lossless_data_size
	drop 4 20 +field WebPAuxStats-PSNR
	drop 152 4 +field WebPAuxStats-histogram_bits
	drop 108 16 +field WebPAuxStats-segment_quant
	drop 92 16 +field WebPAuxStats-segment_size
	drop 168 4 +field WebPAuxStats-lossless_size
	drop 180 8 +field WebPAuxStats-pad
	drop 148 4 +field WebPAuxStats-lossless_features
	drop 164 4 +field WebPAuxStats-palette_size
drop 188 end-structure
\ struct WebPMemoryWriter
begin-structure WebPMemoryWriter
	drop 0 8 +field WebPMemoryWriter-mem
	drop 8 8 +field WebPMemoryWriter-size
	drop 16 8 +field WebPMemoryWriter-max_size
	drop 24 4 +field WebPMemoryWriter-pad
drop 32 end-structure
\ struct WebPPicture
begin-structure WebPPicture
	drop 144 8 +field WebPPicture-progress_hook
	drop 16 8 +field WebPPicture-y
	drop 224 8 +field WebPPicture-memory_
	drop 12 4 +field WebPPicture-height
	drop 60 8 +field WebPPicture-pad1
	drop 136 4 +field WebPPicture-error_code
	drop 84 12 +field WebPPicture-pad2
	drop 120 8 +field WebPPicture-extra_info
	drop 152 8 +field WebPPicture-user_data
	drop 160 12 +field WebPPicture-pad3
	drop 176 8 +field WebPPicture-pad4
	drop 96 8 +field WebPPicture-writer
	drop 184 8 +field WebPPicture-pad5
	drop 192 32 +field WebPPicture-pad6
	drop 8 4 +field WebPPicture-width
	drop 112 4 +field WebPPicture-extra_info_type
	drop 128 8 +field WebPPicture-stats
	drop 240 16 +field WebPPicture-pad7
	drop 80 4 +field WebPPicture-argb_stride
	drop 56 4 +field WebPPicture-a_stride
	drop 44 4 +field WebPPicture-uv_stride
	drop 40 4 +field WebPPicture-y_stride
	drop 48 8 +field WebPPicture-a
	drop 4 4 +field WebPPicture-colorspace
	drop 72 8 +field WebPPicture-argb
	drop 0 4 +field WebPPicture-use_argb
	drop 104 8 +field WebPPicture-custom_ptr
	drop 232 8 +field WebPPicture-memory_argb_
	drop 24 8 +field WebPPicture-u
	drop 32 8 +field WebPPicture-v
drop 256 end-structure

\ ------===< callbacks >===-------
c-callback WebPWriterFunction: a u a -- n	( data data_size picture -- )
c-callback WebPProgressHook: n a -- n	( percent picture -- )

\ ------===< functions >===-------
c-function WebPMalloc WebPMalloc u -- a	( size -- )
c-function WebPFree WebPFree a -- void	( ptr -- )
c-function WebPGetDecoderVersion WebPGetDecoderVersion  -- n	( -- )
c-function WebPGetInfo WebPGetInfo a u a a -- n	( data data_size width height -- )
c-function WebPDecodeRGBA WebPDecodeRGBA a u a a -- a	( data data_size width height -- )
c-function WebPDecodeARGB WebPDecodeARGB a u a a -- a	( data data_size width height -- )
c-function WebPDecodeBGRA WebPDecodeBGRA a u a a -- a	( data data_size width height -- )
c-function WebPDecodeRGB WebPDecodeRGB a u a a -- a	( data data_size width height -- )
c-function WebPDecodeBGR WebPDecodeBGR a u a a -- a	( data data_size width height -- )
c-function WebPDecodeYUV WebPDecodeYUV a u a a a a a a -- a	( data data_size width height u v stride uv_stride -- )
c-function WebPDecodeRGBAInto WebPDecodeRGBAInto a u a u n -- a	( data data_size output_buffer output_buffer_size output_stride -- )
c-function WebPDecodeARGBInto WebPDecodeARGBInto a u a u n -- a	( data data_size output_buffer output_buffer_size output_stride -- )
c-function WebPDecodeBGRAInto WebPDecodeBGRAInto a u a u n -- a	( data data_size output_buffer output_buffer_size output_stride -- )
c-function WebPDecodeRGBInto WebPDecodeRGBInto a u a u n -- a	( data data_size output_buffer output_buffer_size output_stride -- )
c-function WebPDecodeBGRInto WebPDecodeBGRInto a u a u n -- a	( data data_size output_buffer output_buffer_size output_stride -- )
c-function WebPDecodeYUVInto WebPDecodeYUVInto a u a u n a u n a u n -- a	( data data_size luma luma_size luma_stride u u_size u_stride v v_size v_stride -- )
c-function WebPIsPremultipliedMode WebPIsPremultipliedMode n -- n	( mode -- )
c-function WebPIsAlphaMode WebPIsAlphaMode n -- n	( mode -- )
c-function WebPIsRGBMode WebPIsRGBMode n -- n	( mode -- )
c-function WebPInitDecBufferInternal WebPInitDecBufferInternal a n -- n	( <noname> <noname> -- )
c-function WebPInitDecBuffer WebPInitDecBuffer a -- n	( buffer -- )
c-function WebPFreeDecBuffer WebPFreeDecBuffer a -- void	( buffer -- )
c-function WebPINewDecoder WebPINewDecoder a -- a	( output_buffer -- )
c-function WebPINewRGB WebPINewRGB n a u n -- a	( csp output_buffer output_buffer_size output_stride -- )
c-function WebPINewYUVA WebPINewYUVA a u n a u n a u n a u n -- a	( luma luma_size luma_stride u u_size u_stride v v_size v_stride a a_size a_stride -- )
c-function WebPINewYUV WebPINewYUV a u n a u n a u n -- a	( luma luma_size luma_stride u u_size u_stride v v_size v_stride -- )
c-function WebPIDelete WebPIDelete a -- void	( idec -- )
c-function WebPIAppend WebPIAppend a a u -- n	( idec data data_size -- )
c-function WebPIUpdate WebPIUpdate a a u -- n	( idec data data_size -- )
c-function WebPIDecGetRGB WebPIDecGetRGB a a a a a -- a	( idec last_y width height stride -- )
c-function WebPIDecGetYUVA WebPIDecGetYUVA a a a a a a a a a a -- a	( idec last_y u v a width height stride uv_stride a_stride -- )
c-function WebPIDecGetYUV WebPIDecGetYUV a a a a a a a a -- a	( idec last_y u v width height stride uv_stride -- )
c-function WebPIDecodedArea WebPIDecodedArea a a a a a -- a	( idec left top width height -- )
c-function WebPGetFeaturesInternal WebPGetFeaturesInternal a u a n -- n	( <noname> <noname> <noname> <noname> -- )
c-function WebPGetFeatures WebPGetFeatures a u a -- n	( data data_size features -- )
c-function WebPInitDecoderConfigInternal WebPInitDecoderConfigInternal a n -- n	( <noname> <noname> -- )
c-function WebPInitDecoderConfig WebPInitDecoderConfig a -- n	( config -- )
c-function WebPIDecode WebPIDecode a u a -- a	( data data_size config -- )
c-function WebPDecode WebPDecode a u a -- n	( data data_size config -- )
c-function WebPGetEncoderVersion WebPGetEncoderVersion  -- n	( -- )
c-function WebPEncodeRGB WebPEncodeRGB a n n n r a -- u	( rgb width height stride quality_factor output -- )
c-function WebPEncodeBGR WebPEncodeBGR a n n n r a -- u	( bgr width height stride quality_factor output -- )
c-function WebPEncodeRGBA WebPEncodeRGBA a n n n r a -- u	( rgba width height stride quality_factor output -- )
c-function WebPEncodeBGRA WebPEncodeBGRA a n n n r a -- u	( bgra width height stride quality_factor output -- )
c-function WebPEncodeLosslessRGB WebPEncodeLosslessRGB a n n n a -- u	( rgb width height stride output -- )
c-function WebPEncodeLosslessBGR WebPEncodeLosslessBGR a n n n a -- u	( bgr width height stride output -- )
c-function WebPEncodeLosslessRGBA WebPEncodeLosslessRGBA a n n n a -- u	( rgba width height stride output -- )
c-function WebPEncodeLosslessBGRA WebPEncodeLosslessBGRA a n n n a -- u	( bgra width height stride output -- )
c-function WebPConfigInitInternal WebPConfigInitInternal a n r n -- n	( <noname> <noname> <noname> <noname> -- )
c-function WebPConfigInit WebPConfigInit a -- n	( config -- )
c-function WebPConfigPreset WebPConfigPreset a n r -- n	( config preset quality -- )
c-function WebPConfigLosslessPreset WebPConfigLosslessPreset a n -- n	( config level -- )
c-function WebPValidateConfig WebPValidateConfig a -- n	( config -- )
c-function WebPMemoryWriterInit WebPMemoryWriterInit a -- void	( writer -- )
c-function WebPMemoryWriterClear WebPMemoryWriterClear a -- void	( writer -- )
c-function WebPMemoryWrite WebPMemoryWrite a u a -- n	( data data_size picture -- )
c-function WebPPictureInitInternal WebPPictureInitInternal a n -- n	( <noname> <noname> -- )
c-function WebPPictureInit WebPPictureInit a -- n	( picture -- )
c-function WebPPictureAlloc WebPPictureAlloc a -- n	( picture -- )
c-function WebPPictureFree WebPPictureFree a -- void	( picture -- )
c-function WebPPictureCopy WebPPictureCopy a a -- n	( src dst -- )
c-function WebPPlaneDistortion WebPPlaneDistortion a u a u n n u n a a -- n	( src src_stride ref ref_stride width height x_step type distortion result -- )
c-function WebPPictureDistortion WebPPictureDistortion a a n a -- n	( src ref metric_type result -- )
c-function WebPPictureCrop WebPPictureCrop a n n n n -- n	( picture left top width height -- )
c-function WebPPictureView WebPPictureView a n n n n a -- n	( src left top width height dst -- )
c-function WebPPictureIsView WebPPictureIsView a -- n	( picture -- )
c-function WebPPictureRescale WebPPictureRescale a n n -- n	( picture width height -- )
c-function WebPPictureImportRGB WebPPictureImportRGB a a n -- n	( picture rgb rgb_stride -- )
c-function WebPPictureImportRGBA WebPPictureImportRGBA a a n -- n	( picture rgba rgba_stride -- )
c-function WebPPictureImportRGBX WebPPictureImportRGBX a a n -- n	( picture rgbx rgbx_stride -- )
c-function WebPPictureImportBGR WebPPictureImportBGR a a n -- n	( picture bgr bgr_stride -- )
c-function WebPPictureImportBGRA WebPPictureImportBGRA a a n -- n	( picture bgra bgra_stride -- )
c-function WebPPictureImportBGRX WebPPictureImportBGRX a a n -- n	( picture bgrx bgrx_stride -- )
c-function WebPPictureARGBToYUVA WebPPictureARGBToYUVA a n -- n	( picture <noname> -- )
c-function WebPPictureARGBToYUVADithered WebPPictureARGBToYUVADithered a n r -- n	( picture colorspace dithering -- )
c-function WebPPictureSharpARGBToYUVA WebPPictureSharpARGBToYUVA a -- n	( picture -- )
c-function WebPPictureSmartARGBToYUVA WebPPictureSmartARGBToYUVA a -- n	( picture -- )
c-function WebPPictureYUVAToARGB WebPPictureYUVAToARGB a -- n	( picture -- )
c-function WebPCleanupTransparentArea WebPCleanupTransparentArea a -- void	( picture -- )
c-function WebPPictureHasTransparency WebPPictureHasTransparency a -- n	( picture -- )
c-function WebPBlendAlpha WebPBlendAlpha a u -- void	( picture background_rgb -- )
c-function WebPEncode WebPEncode a a -- n	( config picture -- )

\ ----===< postfix >===-----
end-c-library
previous set-current
